format MS COFF

include '\fasm\include\macro\macros.inc'

section '.text' code readable executable

proc RadixSort,pAry,aSze ;aSze in BYTES not dwords
; Sort an array "pAry" of signed ints.
enter
	push edi esi ebx ebp

	mov edi,[pAry]
	mov ebp,[aSze]

	mov eax,1
	lea ecx,[edi+ebp]
	xor edx,edx

	.logLp:	mov esi,edi
		cmp esi,ecx
		je .tst1Ed

		.tst1Lp:test [esi],eax
			jnz .OnBit1

			inc edx

			; Zero Bit

		add esi,4
		cmp esi,ecx
		jne .tst1Lp
		jmp .tst1Ed

		.OnBit1:

			inc edx
			; One Bit

		add esi,4
		cmp esi,ecx
		jne .tst1Lp
	.tst1Ed:
		lea esi,[edi+ebp-4]
		cmp esi,ecx
		jl .tst2Ed

		.tst2Lp:test [esi],eax
			jnz .OnBit2

			inc edx

			; Zero Bit

		sub esi,4
		cmp esi,ecx
		jge .tst2Lp
		jmp .tst2Ed

		.OnBit2:

			inc edx
			; One Bit

		sub esi,4
		cmp esi,ecx
		jge .tst2Lp
	.tst2Ed:

.logNx:	shl eax,1
	jnz .logLp

	pop ebp ebx esi edi
	mov eax,edx
return
Global RadixSort
