format MS COFF

include '\fasm\include\macro\macros.inc'

section '.text' code readable executable

proc QuickSort,pAry,aSze ;aSze in BYTES not dwords
; Sort an array "pAry" of signed ints.
enter
	mov eax,[aSze]
	push edi esi ebx
	sub eax,4
	mov ebx,[pAry]
	push eax 0 ;eax 0
	call qsort
;	call isort
	pop ebx esi edi
return

rgh equ esp+8
lft equ esp+4
M equ 20;32

align 16
qsort:	mov edi,[rgh]
	mov esi,[lft]

	mov eax,edi
	lea ecx,[esi+edi]
	sub eax,esi
	shr ecx,1
	cmp eax,M*4
	jle .ex
	and ecx,not 3

	; Tri-Median
	mov edx,[ebx+edi]
	mov eax,[ebx+esi]
	cmp eax,edx			;cmp
	cmova edx,eax
	cmova eax,[ebx+edi]
	mov [ebx+edi],edx
	mov [ebx+esi],eax

	mov eax,[ebx+ecx]
	mov edx,[ebx+edi]
	cmp eax,edx			;cmp
	cmova edx,eax
	cmova eax,[ebx+edi]
	mov [ebx+edi],edx
	mov [ebx+ecx],eax

	mov eax,[ebx+esi]
	mov edx,[ebx+ecx]
	cmp eax,edx			;cmp
	cmovbe edx,eax
	cmovbe eax,[ebx+ecx]
	mov [ebx+ecx],edx
	mov [ebx+esi],eax

	sub edi,4
	mov eax,[ebx+esi]
	mov edx,[ebx+edi]
	mov [ebx+edi],eax
	mov [ebx+esi],edx

	mov edx,[ebx+edi]
	.lpFor:
	.wle1:	add esi,4
		cmp [ebx+esi],edx 	;cmp
		jb .wle1
	.wle2:	sub edi,4
		cmp [ebx+edi],edx	;cmp
		ja .wle2
		cmp esi,edi
		jg .exFor

		mov eax,[ebx+esi]
		mov ecx,[ebx+edi]
		mov [ebx+edi],eax
		mov [ebx+esi],ecx
	jmp .lpFor
.exFor:
	mov ecx,[rgh]

	mov eax,[ebx+esi]
	mov edx,[ebx+ecx-4]

	sub ecx,4
	add esi,4

	push pd[rgh]
	push esi
	push edi
	push pd[lft+12]

	mov [ebx+ecx],eax
	mov [ebx+esi-4],edx

	call qsort
	call qsort
.ex:
retn 8

align 16
isort:	mov ecx,[lft]
	mov edi,[rgh]

	lea esi,[ecx+4]
	jmp .nxFor
	.lpFor:	mov edx,[ebx+esi]
		mov edi,esi
		jmp .nxWle
		.lpWle:	mov eax,[ebx-4+edi]
			sub edi,4
			mov [ebx+4+edi],eax
		.nxWle:	cmp edi,ecx
		jle .exWle
			cmp edx,[ebx-4+edi]			;cmp
		jb .lpWle
	.exWle:	mov [ebx+edi],edx
		add esi,4
	.nxFor:	cmp esi,[rgh]
	jle .lpFor
.exFor:
retn 8

Global QuickSort

;        int M = 4;
;        int i;
;        int j;
;        int v;
;
;        if ((r-l)>M)
;        {
;                i = (r+l)/2;
;                if (a[l]>a[i]) swap(a,l,i);     // Tri-Median Methode!
;                if (a[l]>a[r]) swap(a,l,r);
;                if (a[i]>a[r]) swap(a,i,r);
;
;                j = r-1;
;                swap(a,i,j);
;                i = l;
;                v = a[j];
;                for(;;)
;                {
;                        while(a[++i]<v);
;                        while(a[--j]>v);
;                        if (j<i) break;
;                        swap (a,i,j);
;                        pause(i,j);
;                        if (stopRequested) {
;                            return;
;                        }
;                }
;                swap(a,i,r-1);
;                pause(i);
;                QuickSort(a,l,j);
;                QuickSort(a,i+1,r);
;        }
;    }

;    private void InsertionSort(int a[], int lo0, int hi0) throws Exception
;    {
;            int i;
;            int j;
;            int v;
;
;            for (i=lo0+1;i<=hi0;i++)
;            {
;                    v = a[i];
;                    j=i;
;                    while ((j>lo0) && (a[j-1]>v))
;                    {
;                            a[j] = a[j-1];
;                            pause(i,j);
;                            j--;
;                    }
;                    a[j] = v;
;            }
;    }
