format MS COFF

include '\fasm\include\macro\macros.inc'

section '.text' code readable executable

proc QuickSortFun,pAry,aSze,fCmp ;aSze in BYTES not dwords
; Sort an array "pAry" of DWORDs/Objects.

; fCmp is a pointer to a stdcall function which will compare two dwords, or
; the objects they point to. It should return the result of the comparasion
; in the flags. That is Less than, Equal to or Greater than.
enter
	mov eax,[aSze]
	push edi esi ebx ebp
	sub eax,4
	mov ebx,[pAry]
	mov ebp,[fCmp]
	push eax 0 eax 0
	call qsort
	call isort
	pop ebp ebx esi edi
return

rgh equ esp+8
lft equ esp+4

align 4
rgh equ esp+8
lft equ esp+4

qsort:	mov edi,[rgh]
	mov esi,[lft]

;	FileDbg 'Here 1%s',NL

	mov eax,edi
	lea ebp,[esi+edi]
	sub eax,esi
	shr ebp,1
	cmp eax,8*4
	jle .ex
	and ebp,not 3

	; Tri-Median
	stdcall CmpInt,pd[ebx+esi],pd[ebx+edi]
	jle @F
	mov eax,[ebx+esi]
	mov edx,[ebx+edi]
	mov [ebx+edi],eax
	mov [ebx+esi],edx
@@:
	stdcall CmpInt,pd[ebx+ebp],pd[ebx+edi]
	jle @F
	mov eax,[ebx+ebp]
	mov edx,[ebx+edi]
	mov [ebx+edi],eax
	mov [ebx+ebp],edx
@@:
	stdcall CmpInt,pd[ebx+esi],pd[ebx+ebp]
	jg @F
	mov eax,[ebx+esi]
	mov edx,[ebx+ebp]
	mov [ebx+ebp],eax
	mov [ebx+esi],edx
@@:
	sub edi,4
	mov eax,[ebx+esi]
	mov edx,[ebx+edi]
	mov [ebx+edi],eax
	mov [ebx+esi],edx

;	FileDbg 'Here 2%s',NL
	mov ebp,[ebx+edi]

	.lpFor:
	.wle1:	add esi,4
		stdcall CmpInt,pd[ebx+esi],ebp
		jl .wle1
	.wle2:	sub edi,4
		stdcall CmpInt,pd[ebx+edi],ebp
		jg .wle2
		cmp esi,edi
		jg .exFor

		mov eax,[ebx+esi]
		mov ecx,[ebx+edi]
		mov [ebx+edi],eax
		mov [ebx+esi],ecx
	jmp .lpFor
.exFor:
	mov ecx,[rgh]
	sub ecx,4

	mov eax,[ebx+esi]
	mov edx,[ebx+ecx]
	mov [ebx+ecx],eax
	mov [ebx+esi],edx

	add esi,4
	mov eax,[lft]

	push pd[rgh]
	push esi
	push edi
	push eax
	call qsort
	call qsort
.ex:
retn 8
qsortSze = $-qsort

isort:	mov ecx,[lft]
	mov edi,[rgh]

	lea esi,[ecx+4]
	jmp .nxFor
	.lpFor:	mov ebp,[ebx+esi]
		mov edi,esi
		jmp .nxWle
		.lpWle:	mov eax,[ebx-4+edi]
			sub edi,4
			mov [ebx+4+edi],eax
		.nxWle:	cmp edi,[lft]
		jle .exWle
			stdcall CmpInt,pd[ebx-4+edi],ebp
		jge .lpWle
	.exWle:	mov [ebx+edi],ebp
		add esi,4
	.nxFor:	cmp esi,[rgh]
	jle .lpFor
.exFor:
retn 8
isortSze = $-isort

Global QuickSortFun

proc CmpInt,pInt1,pInt2
enter
	mov eax,[pInt1]
	cmp eax,[pInt2]
return

;        int M = 4;
;        int i;
;        int j;
;        int v;
;
;        if ((r-l)>M)
;        {
;                i = (r+l)/2;
;                if (a[l]>a[i]) swap(a,l,i);     // Tri-Median Methode!
;                if (a[l]>a[r]) swap(a,l,r);
;                if (a[i]>a[r]) swap(a,i,r);
;
;                j = r-1;
;                swap(a,i,j);
;                i = l;
;                v = a[j];
;                for(;;)
;                {
;                        while(a[++i]<v);
;                        while(a[--j]>v);
;                        if (j<i) break;
;                        swap (a,i,j);
;                        pause(i,j);
;                        if (stopRequested) {
;                            return;
;                        }
;                }
;                swap(a,i,r-1);
;                pause(i);
;                QuickSort(a,l,j);
;                QuickSort(a,i+1,r);
;        }
;    }

;    private void InsertionSort(int a[], int lo0, int hi0) throws Exception
;    {
;            int i;
;            int j;
;            int v;
;
;            for (i=lo0+1;i<=hi0;i++)
;            {
;                    v = a[i];
;                    j=i;
;                    while ((j>lo0) && (a[j-1]>v))
;                    {
;                            a[j] = a[j-1];
;                            pause(i,j);
;                            j--;
;                    }
;                    a[j] = v;
;            }
;    }