format MS COFF

include '\fasm\include\kernel32.inc'
include '\fasm\include\comctl32.inc'
include '\fasm\include\gdi32.inc'
include '\fasm\include\user32.inc'

include '\fasm\include\macro\macros.inc'
include '\fasm\include\printf.asm'
include '\fasm\include\debug.inc'

include 'dsa.inc'

include 'Abstract.asm'

section '.data' data readable writeable

gIst dd 0
gWnd dd 0
gFle dd 0

Buff rb 512
Size dd 0
Time dd 0

section '.text' code readable executable

proc CmpInt,pInt1,pInt2
enter
	mov eax,[pInt1]
	cmp eax,[pInt2]
return

proc DlgProc,hWnd,uMsg,wParam,lParam
enter
	push edi esi ebx

	mov eax,[uMsg]
	WM_CASE eax,COMMAND,CLOSE,INITDIALOG
	xor eax,eax
	jmp .finish

.INITDIALOG:
	mov eax,[hWnd]
	mov [gWnd],eax

;	invoke CreateFile,'Debug.txt',GENERIC_WRITE,FILE_SHARE_WRITE,0,CREATE_ALWAYS,0,0
;	mov [gFle],eax

	ccall StrItem,3000,'QuickSort%s',NL
	ARRAYSIZE equ 10000000*4
	invoke VirtualAlloc,0,ARRAYSIZE,MEM_COMMIT,PAGE_READWRITE
	mov esi,eax

	srand 12345678h
	mov ebx,ARRAYSIZE-4
	.rdLp:	brand; 1,5000000
		mov [esi+ebx],eax
	sub ebx,4
	jns .rdLp
	ccall StrItem,3000,'Array of %i initialised%s',ARRAYSIZE/4,NL

	invoke GetTickCount
	mov [Time],eax
	ccall StrItem,3000,'Start timing at %i%s',[Time],NL
	
	; Unsigned Integer QuickSort
	stdcall QuickSort,esi,ARRAYSIZE
	
	; Generic QuickSort
	;stdcall QuickSortFun,esi,ARRAYSIZE,CmpInt
	
	invoke GetTickCount
	mov edx,eax
	sub eax,[Time]
	ccall StrItem,3000,'End timing at %i, Total %i%s',edx,eax,NL

;	mov ebx,ARRAYSIZE-4
;	.ptLp:	ccall StrFile,[gFle],'%u%s',pd[esi+ebx],NL
;	sub ebx,4
;	jns .ptLp

	invoke VirtualFree,esi,0,MEM_DECOMMIT

;	invoke CloseHandle,[gFle]

	mov eax,1
	jmp .finish

.COMMAND:
	mov eax,[wParam]
	CmpJmp eax,a,1000
	xor eax,eax
	jmp .finish

.a1000:	invoke SendMessage,[hWnd],WM_CLOSE,0,0
	mov eax,1
	jmp .finish

.CLOSE:
	invoke EndDialog,[hWnd],0
	mov eax,1

.finish:pop ebx esi edi
return

public _SrtApp
_SrtApp:invoke GetModuleHandle,eax
	mov [gIst],eax
	invoke DialogBoxParam,eax,1,0,DlgProc,0
ExitApp:invoke ExitProcess,0
        invoke InitCommonControlsEx,0